diff --git a/TAGS b/TAGS
index 40e1640..c22cb0d 100644
--- a/TAGS
+++ b/TAGS
@@ -859,184 +3032,186 @@ pub struct Model {Model15,366
     formula_cache: HashMap<CellKey, CellValue>,formula_cache29,926
 impl Model {Model32,977
     pub fn new(name: impl Into<String>) -> Self {new33,990
-    pub fn add_category(&mut self, name: impl Into<String>) -> Result<CategoryId> {add_category77,2687
-    pub fn add_label_category(&mut self, name: impl Into<String>) -> Result<CategoryId> {add_label_category105,3777
-    pub fn remove_category(&mut self, name: &str) {remove_category124,4524
-    pub fn remove_item(&mut self, cat_name: &str, item_name: &str) {remove_item148,5347
-    pub fn category_mut(&mut self, name: &str) -> Option<&mut Category> {category_mut163,5814
-    pub fn category(&self, name: &str) -> Option<&Category> {category167,5933
-    pub fn set_cell(&mut self, key: CellKey, value: CellValue) {set_cell171,6036
-    pub fn clear_cell(&mut self, key: &CellKey) {clear_cell175,6143
-    pub fn get_cell(&self, key: &CellKey) -> Option<&CellValue> {get_cell179,6231
-    pub fn add_formula(&mut self, formula: Formula) {add_formula183,6331
-    pub fn remove_formula(&mut self, target: &str, target_category: &str) {remove_formula201,7115
-    pub fn formulas(&self) -> &[Formula] {formulas206,7308
-    pub fn active_view(&self) -> &View {active_view210,7381
-    pub fn active_view_mut(&mut self) -> &mut View {active_view_mut216,7549
-    pub fn create_view(&mut self, name: impl Into<String>) -> &mut View {create_view222,7733
-    pub fn switch_view(&mut self, name: &str) -> Result<()> {switch_view233,8146
-    pub fn delete_view(&mut self, name: &str) -> Result<()> {delete_view242,8405
-    pub fn normalize_view_state(&mut self) {normalize_view_state256,8930
-    pub fn category_names(&self) -> Vec<&str> {category_names265,9196
-    pub fn measure_item_names(&self) -> Vec<String> {measure_item_names273,9593
-    pub fn effective_item_names(&self, cat_name: &str) -> Vec<String> {effective_item_names294,10325
-    pub fn regular_category_names(&self) -> Vec<&str> {regular_category_names310,10850
-    const MAX_EVAL_DEPTH: u8 = 16;MAX_EVAL_DEPTH322,11344
-    pub fn evaluate(&self, key: &CellKey) -> Option<CellValue> {evaluate324,11380
-    fn evaluate_depth(&self, key: &CellKey, depth: u8) -> Option<CellValue> {evaluate_depth328,11507
-    pub fn evaluate_aggregated(&self, key: &CellKey, none_cats: &[String]) -> Option<CellValue> evaluate_aggregated345,12257
-    pub fn evaluate_aggregated_f64(&self, key: &CellKey, none_cats: &[String]) -> f64 {evaluate_aggregated_f64384,13586
-    pub fn recompute_formulas(&mut self, none_cats: &[String]) {recompute_formulas398,14232
-    fn evaluate_formula_cell(&self, key: &CellKey, none_cats: &[String]) -> Option<CellValue> {evaluate_formula_cell456,16547
-    fn eval_formula_with_cache(eval_formula_with_cache468,17058
-        fn find_item_category<'a>(model: &'a Model, item_name: &str) -> Option<&'a str> {find_item_category487,17627
-        fn eval_expr_cached(eval_expr_cached503,18256
-        fn eval_bool_cached(eval_bool_cached608,23043
-    fn aggregate_raw(&self, key: &CellKey, none_cats: &[String]) -> Option<CellValue> {aggregate_raw647,24430
-    fn eval_formula_depth(eval_formula_depth674,25406
-        fn find_item_category<'a>(model: &'a Model, item_name: &str) -> Option<&'a str> {find_item_category693,25947
-        fn eval_expr(eval_expr712,26781
-        fn eval_bool(eval_bool801,30819
-mod model_tests {model_tests843,32220
-    fn coord(pairs: &[(&str, &str)]) -> CellKey {coord848,32338
-    fn new_model_has_default_view() {new_model_has_default_view858,32571
-    fn add_category_creates_entry() {add_category_creates_entry865,32781
-    fn add_category_duplicate_is_idempotent() {add_category_duplicate_is_idempotent872,32970
-    fn add_category_max_limit() {add_category_max_limit882,33318
-    fn add_category_notifies_existing_views() {add_category_notifies_existing_views891,33555
-    fn set_and_get_cell_roundtrip() {set_and_get_cell_roundtrip899,33852
-    fn get_unset_cell_returns_empty() {get_unset_cell_returns_empty909,34234
-    fn overwrite_cell() {overwrite_cell916,34417
-    fn three_category_model_independent_cells() {three_category_model_independent_cells925,34725
-    fn remove_category_deletes_category_and_cells() {remove_category_deletes_category_and_cells961,36040
-    fn create_view_copies_category_structure() {create_view_copies_category_structure986,37012
-    fn switch_view_changes_active_view() {switch_view_changes_active_view998,37469
-    fn switch_view_unknown_returns_error() {switch_view_unknown_returns_error1006,37688
-    fn delete_view_removes_it() {delete_view_removes_it1012,37847
-    fn delete_last_view_returns_error() {delete_last_view_returns_error1020,38062
-    fn delete_active_view_switches_to_another() {delete_active_view_switches_to_another1026,38215
-    fn first_category_goes_to_row_second_to_column_rest_to_page() {first_category_goes_to_row_second_to_column_rest_to_page1035,38482
-    fn data_is_shared_across_views() {data_is_shared_across_views1047,38929
-    fn evaluate_aggregated_sums_over_hidden_dimension() {evaluate_aggregated_sums_over_hidden_dimension1056,39230
-    fn measure_item_names_includes_formula_targets() {measure_item_names_includes_formula_targets1097,40789
-    fn evaluate_aggregated_no_hidden_delegates_to_evaluate() {evaluate_aggregated_no_hidden_delegates_to_evaluate1128,41900
-    fn evaluate_aggregated_respects_measure_agg() {evaluate_aggregated_respects_measure_agg1141,42367
-mod formula_tests {formula_tests1172,43506
-    fn coord(pairs: &[(&str, &str)]) -> CellKey {coord1177,43638
-    fn approx_eq(a: f64, b: f64) -> bool {approx_eq1186,43859
-    fn revenue_cost_model() -> Model {revenue_cost_model1190,43938
-    fn profit_equals_revenue_minus_cost() {profit_equals_revenue_minus_cost1223,44978
-    fn formula_evaluates_per_region() {formula_evaluates_per_region1231,45307
-    fn formula_multiplication() {formula_multiplication1241,45782
-    fn formula_division() {formula_division1255,46253
-    fn division_by_zero_yields_empty() {division_by_zero_yields_empty1271,46850
-    fn unary_minus() {unary_minus1297,47802
-    fn power_operator() {power_operator1308,48220
-    fn formula_with_missing_ref_returns_empty() {formula_with_missing_ref_returns_empty1324,48777
-    fn circular_formula_returns_error() {circular_formula_returns_error1340,49408
-    fn self_referencing_formula_returns_error() {self_referencing_formula_returns_error1359,50118
-    fn formula_where_applied_to_matching_region() {formula_where_applied_to_matching_region1375,50673
-    fn formula_where_not_applied_to_non_matching_region() {formula_where_not_applied_to_non_matching_region1391,51219
-    fn add_formula_replaces_same_target() {add_formula_replaces_same_target1406,51701
-    fn remove_formula() {remove_formula1416,52163
-    fn sum_aggregation_across_region() {sum_aggregation_across_region1426,52536
-    fn count_aggregation() {count_aggregation1441,53077
-    fn if_true_branch() {if_true_branch1464,53868
-    fn if_false_branch() {if_false_branch1480,54423
-    fn where_filter_absent_category_does_not_apply_formula() {where_filter_absent_category_does_not_apply_formula1505,55663
-    fn sum_inner_expression_constrains_which_cells_are_summed() {sum_inner_expression_constrains_which_cells_are_summed1530,56928
-    fn add_formula_same_target_name_different_category_both_coexist() {add_formula_same_target_name_different_category_both_coexist1564,58308
-    fn add_formula_same_target_name_different_category_evaluates_independently() {add_formula_same_target_name_different_category_evaluates_independently1586,59187
-    fn formula_chain_preserves_full_precision() {formula_chain_preserves_full_precision1618,60420
-    fn remove_formula_only_removes_specified_target_category() {remove_formula_only_removes_specified_target_category1667,62470
-mod five_category {five_category1695,63384
-    const DATA: &[(&str, &str, &str, &str, f64, f64)] = &[DATA1701,63543
-    fn coord(region: &str, product: &str, channel: &str, time: &str, measure: &str) -> CellKey {coord1720,64534
-    fn build_model() -> Model {build_model1730,64959
-    fn approx(a: f64, b: f64) -> bool {approx1770,66494
-    fn all_sixteen_revenue_cells_stored() {all_sixteen_revenue_cells_stored1775,66582
-    fn all_sixteen_cost_cells_stored() {all_sixteen_cost_cells_stored1785,66871
-    fn spot_check_raw_revenue() {spot_check_raw_revenue1795,67154
-    fn distinct_cells_do_not_alias() {distinct_cells_do_not_alias1808,67543
-    fn profit_formula_correct_at_every_intersection() {profit_formula_correct_at_every_intersection1820,67887
-    fn margin_formula_correct_at_every_intersection() {margin_formula_correct_at_every_intersection1836,68530
-    fn chained_formula_profit_feeds_margin() {chained_formula_profit_feeds_margin1852,69187
-    fn update_revenue_updates_profit_and_margin() {update_revenue_updates_profit_and_margin1862,69510
-    fn sum_revenue_for_east_region() {sum_revenue_for_east_region1881,70205
-    fn sum_revenue_for_online_channel() {sum_revenue_for_online_channel1897,70783
-    fn sum_revenue_for_shirts_q1() {sum_revenue_for_shirts_q11913,71371
-    fn sum_all_revenue_equals_grand_total() {sum_all_revenue_equals_grand_total1930,72017
-    fn default_view_first_two_on_axes_rest_on_page() {default_view_first_two_on_axes_rest_on_page1939,72428
-    fn rearranging_axes_does_not_affect_data() {rearranging_axes_does_not_affect_data1950,72834
-    fn two_views_have_independent_axis_assignments() {two_views_have_independent_axis_assignments1967,73385
-    fn page_selections_are_per_view() {page_selections_are_per_view1987,74112
-    fn five_categories_well_within_limit() {five_categories_well_within_limit2004,74606
-mod prop_tests {prop_tests2019,75118
-    fn finite_f64() -> impl Strategy<Value = f64> {finite_f642025,75277
+    pub fn add_category(&mut self, name: impl Into<String>) -> Result<CategoryId> {add_category73,2445
+    pub fn add_label_category(&mut self, name: impl Into<String>) -> Result<CategoryId> {add_label_category101,3535
+    pub fn remove_category(&mut self, name: &str) {remove_category120,4282
+    pub fn remove_item(&mut self, cat_name: &str, item_name: &str) {remove_item144,5105
+    pub fn category_mut(&mut self, name: &str) -> Option<&mut Category> {category_mut159,5572
+    pub fn category(&self, name: &str) -> Option<&Category> {category163,5691
+    pub fn set_cell(&mut self, key: CellKey, value: CellValue) {set_cell167,5794
+    pub fn clear_cell(&mut self, key: &CellKey) {clear_cell171,5901
+    pub fn get_cell(&self, key: &CellKey) -> Option<&CellValue> {get_cell175,5989
+    pub fn add_formula(&mut self, formula: Formula) {add_formula179,6089
+    pub fn remove_formula(&mut self, target: &str, target_category: &str) {remove_formula198,6873
+    pub fn formulas(&self) -> &[Formula] {formulas203,7066
+    pub fn active_view(&self) -> &View {active_view207,7139
+    pub fn active_view_mut(&mut self) -> &mut View {active_view_mut213,7307
+    pub fn create_view(&mut self, name: impl Into<String>) -> &mut View {create_view219,7491
+    pub fn switch_view(&mut self, name: &str) -> Result<()> {switch_view230,7904
+    pub fn delete_view(&mut self, name: &str) -> Result<()> {delete_view239,8163
+    pub fn normalize_view_state(&mut self) {normalize_view_state253,8688
+    pub fn category_names(&self) -> Vec<&str> {category_names262,8954
+    pub fn measure_item_names(&self) -> Vec<String> {measure_item_names270,9351
+    pub fn effective_item_names(&self, cat_name: &str) -> Vec<String> {effective_item_names291,10083
+    pub fn regular_category_names(&self) -> Vec<&str> {regular_category_names307,10608
+    const MAX_EVAL_DEPTH: u8 = 16;MAX_EVAL_DEPTH319,11102
+    pub fn evaluate(&self, key: &CellKey) -> Option<CellValue> {evaluate321,11138
+    fn evaluate_depth(&self, key: &CellKey, depth: u8) -> Option<CellValue> {evaluate_depth325,11265
+    pub fn evaluate_aggregated(&self, key: &CellKey, none_cats: &[String]) -> Option<CellValue> evaluate_aggregated343,12019
+    pub fn evaluate_aggregated_f64(&self, key: &CellKey, none_cats: &[String]) -> f64 {evaluate_aggregated_f64382,13348
+    pub fn recompute_formulas(&mut self, none_cats: &[String]) {recompute_formulas396,13994
+    fn evaluate_formula_cell(&self, key: &CellKey, none_cats: &[String]) -> Option<CellValue> {evaluate_formula_cell454,16309
+    fn eval_formula_with_cache(eval_formula_with_cache467,16824
+        fn find_item_category<'a>(model: &'a Model, item_name: &str) -> Option<&'a str> {find_item_category486,17393
+        fn eval_expr_cached(eval_expr_cached502,18022
+        fn eval_bool_cached(eval_bool_cached608,22821
+    fn aggregate_raw(&self, key: &CellKey, none_cats: &[String]) -> Option<CellValue> {aggregate_raw647,24208
+    fn eval_formula_depth(eval_formula_depth674,25184
+        fn find_item_category<'a>(model: &'a Model, item_name: &str) -> Option<&'a str> {find_item_category693,25725
+        fn eval_expr(eval_expr712,26559
+        fn eval_bool(eval_bool802,30609
+mod model_tests {model_tests844,32010
+    fn coord(pairs: &[(&str, &str)]) -> CellKey {coord849,32128
+    fn new_model_has_default_view() {new_model_has_default_view859,32361
+    fn new_model_registers_virtuals_in_default_view() {new_model_registers_virtuals_in_default_view868,32735
+    fn add_category_creates_entry() {add_category_creates_entry877,33038
+    fn add_category_duplicate_is_idempotent() {add_category_duplicate_is_idempotent884,33227
+    fn add_category_max_limit() {add_category_max_limit894,33575
+    fn add_category_notifies_existing_views() {add_category_notifies_existing_views903,33812
+    fn set_and_get_cell_roundtrip() {set_and_get_cell_roundtrip911,34109
+    fn get_unset_cell_returns_empty() {get_unset_cell_returns_empty921,34491
+    fn overwrite_cell() {overwrite_cell928,34674
+    fn three_category_model_independent_cells() {three_category_model_independent_cells937,34982
+    fn remove_category_deletes_category_and_cells() {remove_category_deletes_category_and_cells973,36297
+    fn create_view_copies_category_structure() {create_view_copies_category_structure998,37269
+    fn switch_view_changes_active_view() {switch_view_changes_active_view1010,37726
+    fn switch_view_unknown_returns_error() {switch_view_unknown_returns_error1018,37945
+    fn delete_view_removes_it() {delete_view_removes_it1024,38104
+    fn delete_last_view_returns_error() {delete_last_view_returns_error1032,38319
+    fn delete_active_view_switches_to_another() {delete_active_view_switches_to_another1038,38472
+    fn first_category_goes_to_row_second_to_column_rest_to_page() {first_category_goes_to_row_second_to_column_rest_to_page1047,38739
+    fn data_is_shared_across_views() {data_is_shared_across_views1059,39186
+    fn evaluate_aggregated_sums_over_hidden_dimension() {evaluate_aggregated_sums_over_hidden_dimension1068,39487
+    fn measure_item_names_includes_formula_targets() {measure_item_names_includes_formula_targets1109,41046
+    fn evaluate_aggregated_no_hidden_delegates_to_evaluate() {evaluate_aggregated_no_hidden_delegates_to_evaluate1140,42157
+    fn evaluate_aggregated_respects_measure_agg() {evaluate_aggregated_respects_measure_agg1153,42624
+mod formula_tests {formula_tests1184,43763
+    fn coord(pairs: &[(&str, &str)]) -> CellKey {coord1189,43895
+    fn approx_eq(a: f64, b: f64) -> bool {approx_eq1198,44116
+    fn revenue_cost_model() -> Model {revenue_cost_model1202,44195
+    fn profit_equals_revenue_minus_cost() {profit_equals_revenue_minus_cost1235,45235
+    fn formula_evaluates_per_region() {formula_evaluates_per_region1243,45564
+    fn formula_multiplication() {formula_multiplication1253,46039
+    fn formula_division() {formula_division1267,46510
+    fn division_by_zero_yields_empty() {division_by_zero_yields_empty1283,47107
+    fn unary_minus() {unary_minus1309,48059
+    fn power_operator() {power_operator1320,48477
+    fn formula_with_missing_ref_returns_empty() {formula_with_missing_ref_returns_empty1336,49034
+    fn circular_formula_returns_error() {circular_formula_returns_error1352,49665
+    fn self_referencing_formula_returns_error() {self_referencing_formula_returns_error1371,50375
+    fn formula_where_applied_to_matching_region() {formula_where_applied_to_matching_region1387,50930
+    fn formula_where_not_applied_to_non_matching_region() {formula_where_not_applied_to_non_matching_region1403,51476
+    fn add_formula_replaces_same_target() {add_formula_replaces_same_target1418,51958
+    fn remove_formula() {remove_formula1428,52420
+    fn sum_aggregation_across_region() {sum_aggregation_across_region1438,52793
+    fn count_aggregation() {count_aggregation1453,53334
+    fn if_true_branch() {if_true_branch1476,54125
+    fn if_false_branch() {if_false_branch1492,54680
+    fn where_filter_absent_category_does_not_apply_formula() {where_filter_absent_category_does_not_apply_formula1517,55920
+    fn sum_inner_expression_constrains_which_cells_are_summed() {sum_inner_expression_constrains_which_cells_are_summed1542,57185
+    fn add_formula_same_target_name_different_category_both_coexist() {add_formula_same_target_name_different_category_both_coexist1576,58565
+    fn add_formula_same_target_name_different_category_evaluates_independently() {add_formula_same_target_name_different_category_evaluates_independently1598,59444
+    fn formula_chain_preserves_full_precision() {formula_chain_preserves_full_precision1630,60677
+    fn remove_formula_only_removes_specified_target_category() {remove_formula_only_removes_specified_target_category1679,62727
+mod five_category {five_category1707,63641
+    const DATA: &[(&str, &str, &str, &str, f64, f64)] = &[DATA1713,63800
+    fn coord(region: &str, product: &str, channel: &str, time: &str, measure: &str) -> CellKey {coord1732,64791
+    fn build_model() -> Model {build_model1742,65216
+    fn approx(a: f64, b: f64) -> bool {approx1782,66751
+    fn all_sixteen_revenue_cells_stored() {all_sixteen_revenue_cells_stored1787,66839
+    fn all_sixteen_cost_cells_stored() {all_sixteen_cost_cells_stored1797,67127
+    fn spot_check_raw_revenue() {spot_check_raw_revenue1807,67409
+    fn distinct_cells_do_not_alias() {distinct_cells_do_not_alias1820,67798
+    fn profit_formula_correct_at_every_intersection() {profit_formula_correct_at_every_intersection1828,68074
+    fn margin_formula_correct_at_every_intersection() {margin_formula_correct_at_every_intersection1844,68717
+    fn chained_formula_profit_feeds_margin() {chained_formula_profit_feeds_margin1860,69374
+    fn update_revenue_updates_profit_and_margin() {update_revenue_updates_profit_and_margin1870,69697
+    fn sum_revenue_for_east_region() {sum_revenue_for_east_region1889,70392
+    fn sum_revenue_for_online_channel() {sum_revenue_for_online_channel1905,70970
+    fn sum_revenue_for_shirts_q1() {sum_revenue_for_shirts_q11921,71558
+    fn sum_all_revenue_equals_grand_total() {sum_all_revenue_equals_grand_total1938,72204
+    fn default_view_first_two_on_axes_rest_on_page() {default_view_first_two_on_axes_rest_on_page1947,72615
+    fn rearranging_axes_does_not_affect_data() {rearranging_axes_does_not_affect_data1958,73021
+    fn two_views_have_independent_axis_assignments() {two_views_have_independent_axis_assignments1975,73572
+    fn page_selections_are_per_view() {page_selections_are_per_view1995,74299
+    fn five_categories_well_within_limit() {five_categories_well_within_limit2012,74793
+mod prop_tests {prop_tests2027,75305
+    fn finite_f64() -> impl Strategy<Value = f64> {finite_f642033,75464
 
-src/model/cell.rs,4317
-pub struct CellKey(pub Vec<(String, String)>);CellKey9,311
-impl CellKey {CellKey11,359
-    pub fn new(mut coords: Vec<(String, String)>) -> Self {new12,374
-    pub fn get(&self, category: &str) -> Option<&str> {get17,508
-    pub fn with(mut self, category: impl Into<String>, item: impl Into<String>) -> Self {with24,686
-    pub fn without(&self, category: &str) -> Self {without36,1081
-    pub fn matches_partial(&self, partial: &[(String, String)]) -> bool {matches_partial47,1333
-impl std::fmt::Display for CellKey {CellKey54,1521
-    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {fmt55,1558
-pub enum CellValue {CellValue62,1831
-    Number(f64),Number63,1852
-    Text(String),Text64,1869
-    Error(String),Error66,1955
-impl CellValue {CellValue69,1977
-    pub fn as_f64(&self) -> Option<f64> {as_f6470,1994
-    pub fn is_error(&self) -> bool {is_error77,2143
-impl std::fmt::Display for CellValue {CellValue82,2233
-    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {fmt83,2272
-pub struct InternedKey(pub Vec<(Symbol, Symbol)>);InternedKey101,2919
-pub struct DataStore {DataStore106,3152
-    cells: HashMap<InternedKey, CellValue>,cells108,3240
-    pub symbols: SymbolTable,symbols110,3355
-    index: HashMap<(Symbol, Symbol), HashSet<InternedKey>>,index112,3462
-impl Serialize for DataStore {DataStore115,3525
-    fn serialize<S: serde::Serializer>(&self, s: S) -> Result<S::Ok, S::Error> {serialize116,3556
-impl<'de> Deserialize<'de> for DataStore {DataStore127,3912
-    fn deserialize<D: serde::Deserializer<'de>>(d: D) -> Result<Self, D::Error> {deserialize128,3955
-impl DataStore {DataStore138,4260
-    pub fn new() -> Self {new139,4277
-    pub fn intern_key(&mut self, key: &CellKey) -> InternedKey {intern_key144,4381
-    pub fn to_cell_key(&self, ikey: &InternedKey) -> CellKey {to_cell_key149,4573
-    pub fn set(&mut self, key: CellKey, value: CellValue) {set163,4960
-    pub fn get(&self, key: &CellKey) -> Option<&CellValue> {get172,5269
-    fn lookup_key(&self, key: &CellKey) -> Option<InternedKey> {lookup_key178,5485
-    pub fn iter_cells(&self) -> impl Iterator<Item = (CellKey, &CellValue)> {iter_cells188,5850
-    pub fn remove(&mut self, key: &CellKey) {remove192,6000
-    pub fn matching_values(&self, partial: &[(String, String)]) -> Vec<&CellValue> {matching_values207,6496
-    pub fn matching_cells(&self, partial: &[(String, String)]) -> Vec<(CellKey, &CellValue)> {matching_cells246,7752
-mod cell_key {cell_key285,8872
-    fn key(pairs: &[(&str, &str)]) -> CellKey {key288,8912
-    fn coords_are_sorted_by_category_name() {coords_are_sorted_by_category_name298,9143
-    fn get_returns_item_for_known_category() {get_returns_item_for_known_category310,9468
-    fn get_returns_none_for_unknown_category() {get_returns_none_for_unknown_category317,9706
-    fn with_adds_new_coordinate_in_sorted_order() {with_adds_new_coordinate_in_sorted_order323,9862
-    fn with_replaces_existing_coordinate() {with_replaces_existing_coordinate332,10191
-    fn without_removes_coordinate() {without_removes_coordinate339,10430
-    fn without_missing_category_is_noop() {without_missing_category_is_noop347,10703
-    fn matches_partial_full_match() {matches_partial_full_match353,10863
-    fn matches_partial_empty_matches_all() {matches_partial_empty_matches_all360,11105
-    fn matches_partial_wrong_item_no_match() {matches_partial_wrong_item_no_match366,11277
-    fn matches_partial_missing_category_no_match() {matches_partial_missing_category_no_match373,11529
-    fn display_format() {display_format380,11767
-mod data_store {data_store387,11911
-    fn key(pairs: &[(&str, &str)]) -> CellKey {key390,11977
-    fn get_missing_returns_empty() {get_missing_returns_empty400,12208
-    fn set_and_get_roundtrip() {set_and_get_roundtrip406,12368
-    fn overwrite_value() {overwrite_value414,12651
-    fn remove_evicts_key() {remove_evicts_key423,12959
-    fn matching_cells_returns_correct_subset() {matching_cells_returns_correct_subset432,13227
-mod prop_tests {prop_tests456,14067
-    fn pairs_map() -> impl Strategy<Value = Vec<(String, String)>> {pairs_map461,14248
-    fn finite_f64() -> impl Strategy<Value = f64> {finite_f64467,14496
+src/model/cell.rs,4379
+pub struct CellKey(pub Vec<(String, String)>);CellKey10,335
+impl CellKey {CellKey12,383
+    pub fn new(mut coords: Vec<(String, String)>) -> Self {new13,398
+    pub fn get(&self, category: &str) -> Option<&str> {get18,532
+    pub fn with(mut self, category: impl Into<String>, item: impl Into<String>) -> Self {with25,710
+    pub fn without(&self, category: &str) -> Self {without37,1105
+    pub fn matches_partial(&self, partial: &[(String, String)]) -> bool {matches_partial48,1357
+impl std::fmt::Display for CellKey {CellKey55,1545
+    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {fmt56,1582
+pub enum CellValue {CellValue63,1855
+    Number(f64),Number64,1876
+    Text(String),Text65,1893
+    Error(String),Error67,1979
+impl CellValue {CellValue70,2001
+    pub fn as_f64(&self) -> Option<f64> {as_f6471,2018
+    pub fn is_error(&self) -> bool {is_error78,2167
+impl std::fmt::Display for CellValue {CellValue83,2257
+    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {fmt84,2296
+pub struct InternedKey(pub Vec<(Symbol, Symbol)>);InternedKey102,2943
+pub struct DataStore {DataStore107,3176
+    cells: IndexMap<InternedKey, CellValue>,cells110,3333
+    pub symbols: SymbolTable,symbols112,3449
+    index: HashMap<(Symbol, Symbol), HashSet<InternedKey>>,index114,3556
+impl Serialize for DataStore {DataStore117,3619
+    fn serialize<S: serde::Serializer>(&self, s: S) -> Result<S::Ok, S::Error> {serialize118,3650
+impl<'de> Deserialize<'de> for DataStore {DataStore129,4006
+    fn deserialize<D: serde::Deserializer<'de>>(d: D) -> Result<Self, D::Error> {deserialize130,4049
+impl DataStore {DataStore140,4354
+    pub fn new() -> Self {new141,4371
+    pub fn intern_key(&mut self, key: &CellKey) -> InternedKey {intern_key146,4475
+    pub fn to_cell_key(&self, ikey: &InternedKey) -> CellKey {to_cell_key151,4667
+    pub fn sort_by_key(&mut self) {sort_by_key168,5243
+    pub fn set(&mut self, key: CellKey, value: CellValue) {set185,5794
+    pub fn get(&self, key: &CellKey) -> Option<&CellValue> {get194,6103
+    fn lookup_key(&self, key: &CellKey) -> Option<InternedKey> {lookup_key200,6319
+    pub fn iter_cells(&self) -> impl Iterator<Item = (CellKey, &CellValue)> {iter_cells210,6684
+    pub fn remove(&mut self, key: &CellKey) {remove214,6834
+    pub fn matching_values(&self, partial: &[(String, String)]) -> Vec<&CellValue> {matching_values229,7336
+    pub fn matching_cells(&self, partial: &[(String, String)]) -> Vec<(CellKey, &CellValue)> {matching_cells268,8592
+mod cell_key {cell_key307,9712
+    fn key(pairs: &[(&str, &str)]) -> CellKey {key310,9752
+    fn coords_are_sorted_by_category_name() {coords_are_sorted_by_category_name320,9983
+    fn get_returns_item_for_known_category() {get_returns_item_for_known_category332,10308
+    fn get_returns_none_for_unknown_category() {get_returns_none_for_unknown_category339,10546
+    fn with_adds_new_coordinate_in_sorted_order() {with_adds_new_coordinate_in_sorted_order345,10702
+    fn with_replaces_existing_coordinate() {with_replaces_existing_coordinate354,11031
+    fn without_removes_coordinate() {without_removes_coordinate361,11270
+    fn without_missing_category_is_noop() {without_missing_category_is_noop369,11543
+    fn matches_partial_full_match() {matches_partial_full_match375,11703
+    fn matches_partial_empty_matches_all() {matches_partial_empty_matches_all382,11945
+    fn matches_partial_wrong_item_no_match() {matches_partial_wrong_item_no_match388,12117
+    fn matches_partial_missing_category_no_match() {matches_partial_missing_category_no_match395,12369
+    fn display_format() {display_format402,12607
+mod data_store {data_store409,12751
+    fn key(pairs: &[(&str, &str)]) -> CellKey {key412,12817
+    fn get_missing_returns_empty() {get_missing_returns_empty422,13048
+    fn set_and_get_roundtrip() {set_and_get_roundtrip428,13208
+    fn overwrite_value() {overwrite_value436,13491
+    fn remove_evicts_key() {remove_evicts_key445,13799
+    fn matching_cells_returns_correct_subset() {matching_cells_returns_correct_subset454,14067
+mod prop_tests {prop_tests478,14907
+    fn pairs_map() -> impl Strategy<Value = Vec<(String, String)>> {pairs_map483,15088
+    fn finite_f64() -> impl Strategy<Value = f64> {finite_f64489,15336
 
 src/model/mod.rs,109
 pub mod category;category1,0
